> ## Documentation Index
> Fetch the complete documentation index at: https://docs.haiqu.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Pretraining

> Pretraining endpoint. Creates a pretraining job.

Args:
    user (User): User authenticated with api key.
    data (PretrainingSubmitModel): Pretraining job arguments.
    db: Database.

Returns:
    PretrainingJobModel: The new job object.



## OpenAPI

````yaml https://api.haiqu.ai/openapi.json post /pretraining
openapi: 3.1.0
info:
  title: Haiqu API
  summary: Haiqu RESTful API service.
  description: Cloud service providing the access to Haiqu cloud runtime
  contact:
    name: Haiqu Inc.
    url: https://haiqu.ai/
    email: info@haiqu.ai
  version: 1.4.0
servers: []
security: []
paths:
  /pretraining:
    post:
      summary: Pretraining
      description: |-
        Pretraining endpoint. Creates a pretraining job.

        Args:
            user (User): User authenticated with api key.
            data (PretrainingSubmitModel): Pretraining job arguments.
            db: Database.

        Returns:
            PretrainingJobModel: The new job object.
      operationId: pretraining_pretraining_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PretrainingSubmitModel'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PretrainingJobModel'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyQuery: []
        - APIKeyHeader: []
components:
  schemas:
    PretrainingSubmitModel:
      properties:
        experiment_id:
          type: string
          title: Experiment Id
        circuit_id:
          type: string
          title: Circuit Id
        loss_expression:
          type: string
          title: Loss Expression
        observables:
          additionalProperties:
            prefixItems:
              - items:
                  type: string
                type: array
              - items:
                  type: number
                type: array
            type: array
            maxItems: 2
            minItems: 2
          type: object
          title: Observables
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
          default: ''
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
          default: ''
        max_time:
          anyOf:
            - type: number
            - type: 'null'
          title: Max Time
        seed:
          anyOf:
            - type: integer
            - type: 'null'
          title: Seed
        initial_parameters:
          anyOf:
            - items:
                type: number
              type: array
            - type: 'null'
          title: Initial Parameters
        options:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Options
        pretrain_type:
          type: string
          title: Pretrain Type
          default: Pretrain
      type: object
      required:
        - experiment_id
        - circuit_id
        - loss_expression
        - observables
      title: PretrainingSubmitModel
      description: Submit model for pretraining variational circuits.
    PretrainingJobModel:
      properties:
        id:
          type: string
          title: Id
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        user_id:
          type: integer
          title: User Id
        experiment_id:
          type: string
          title: Experiment Id
        status:
          $ref: '#/components/schemas/JobStatus'
        job_type:
          $ref: '#/components/schemas/JobType'
        device_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Device Id
          default: Haiqu OS
        creation_date:
          type: string
          format: date-time
          title: Creation Date
        run_date:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Run Date
        finish_date:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Finish Date
        logs:
          anyOf:
            - type: string
            - type: 'null'
          title: Logs
        quality:
          anyOf:
            - type: number
            - type: 'null'
          title: Quality
        info:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Info
        time:
          anyOf:
            - type: number
            - type: 'null'
          title: Time
        parameters:
          anyOf:
            - additionalProperties: true
              type: object
            - items: {}
              type: array
            - type: 'null'
          title: Parameters
        circuit_id:
          type: string
          title: Circuit Id
        loss_expression:
          type: string
          title: Loss Expression
        observables:
          additionalProperties:
            prefixItems:
              - items:
                  type: string
                type: array
              - items:
                  type: number
                type: array
            type: array
            maxItems: 2
            minItems: 2
          type: object
          title: Observables
        max_time:
          anyOf:
            - type: number
            - type: 'null'
          title: Max Time
        seed:
          anyOf:
            - type: integer
            - type: 'null'
          title: Seed
        initial_parameters:
          anyOf:
            - items:
                type: number
              type: array
            - type: 'null'
          title: Initial Parameters
        options:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Options
        pretrain_type:
          $ref: '#/components/schemas/PretrainingJobType'
          default: Pretrain
        result_vector:
          anyOf:
            - items:
                type: number
              type: array
            - type: 'null'
          title: Result Vector
        loss:
          anyOf:
            - type: number
            - type: 'null'
          title: Loss
      type: object
      required:
        - id
        - user_id
        - experiment_id
        - status
        - job_type
        - creation_date
        - circuit_id
        - loss_expression
        - observables
      title: PretrainingJobModel
      description: Job model for pretraining variational circuits.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    JobStatus:
      type: string
      enum:
        - Submitted
        - Initializing
        - Queued
        - Validating
        - Running
        - Cancelled
        - Done
        - Error
      title: JobStatus
      description: Class for job status.
    JobType:
      type: string
      enum:
        - User local job
        - Analytics
        - Device specific analytics
        - Data Loading
        - Hybrid
        - Run
        - State Compression
        - Transpilation
        - Variational
        - Pretraining
        - SKQD
      title: JobType
      description: Class for job types.
    PretrainingJobType:
      type: string
      enum:
        - Pretrain
        - MpsGradient
      title: PretrainingJobType
      description: Class for `pretrain_type`.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyQuery:
      type: apiKey
      in: query
      name: HAIQU_API_KEY
    APIKeyHeader:
      type: apiKey
      in: header
      name: authorization

````